from OpenGL.GLU import *
from OpenGL.GL import *

import numpy as np


class Renderable:
    def render(self, projMatrix, geometryRotMatrix, alternateprograms=None,
               preselected_program=None, projection_pos=None, rot_pos=None):
        pass

    @staticmethod
    def check_error(message):
        gl_error = glGetError()
        if (gl_error != GL_NO_ERROR):
            print("Error: " + message)
            if (gluErrorString(gl_error)):
                print(gluErrorString(gl_error))
            else:
                print(hex(gl_error))
            return True
        return False
