from MatrixStuff.Transformations import *
from Objects.Identifiable import Identifiable


class Light(Identifiable):
    programId = {}
    depthshaderId = -1

    def getDepthProgram(self, vertexshader=-1, geometryshader=-1):
        pass

    def __init__(self):
        super(Light, self).__init__()
        self._ModelviewProjectionMatrix = np.identity(4)
        self._pos = [0, 0, 0]
        self._lightColor = [1, 1, 1]
        self.FramebufferId = -1
        self.DepthBuffer = -1
        self.map_size = 1024

    @property
    def lightColor(self):
        return self._lightColor

    @lightColor.setter
    def lightColor(self, value):
        self._lightColor = value

    @property
    def ModelviewProjectionMatrix(self):
        return self._ModelviewProjectionMatrix

    @ModelviewProjectionMatrix.setter
    def ModelviewProjectionMatrix(self, value):
        self._ModelviewProjectionMatrix = np.matrix(value)

    @property
    def pos(self):
        return self._pos

    @pos.setter
    def pos(self, value):
        self._pos = value

    def prepareForDepthMapping(self):
        pass

    def finishDepthMapping(self):
        pass
