from FluidSim.StaggeredArray import StaggeredArray2D


def test_staggered_array_2D():
    sa = StaggeredArray2D(10, 10)

    for x in range(11):
        for y in range(10):
            sa.u_x[x, y] = y

    for x in range(10):
        for y in range(11):
            sa.u_y[x, y] = x

    ux, uy = sa.get_velocity_arrays()

    for x in range(10):
        for y in range(10):
            ux2, uy2 = sa.get_velocity(x, y)

            assert ux[x, y] == ux2, 'value output should be consistent!'
            assert uy[x, y] == uy2, 'value output should be consistent!'
